// ANNForecastAppAgent.h 

// ANNForecastAppAgent inherits from BasicSumAgent and follows ForecastingAgent
// estimates of future prices
// the agent buys/sells if the forecasting index is > or < than 1; if ==1 doesn't
// act; we can have also an inactivityRange, so more exacltly the agent acts
// only if the forecasting index is > 1+aNNInactivityRange or <1-aNNInactivityRange

// this kind of agents uses also a probability of acting in each day defined by the
// aNNForecastAppAgentActDailyProb value

// anyway, in case of price sliding below the floor price, a buying behavior
// prevails

#import <random.h>
#import "BasicSumAgent.h"
#import "RandomRuleMaster.h"
#import "ForecastingAgent.h"

@interface ANNForecastAppAgent: BasicSumAgent
{
  float aNNInactivityRange, aNNForecastAppAgentActDailyProb;

  RandomRuleMaster * ruleMaster;
  ForecastingAgent * forecastingAgent;
  id <UniformDoubleDist> myUniformDblRand;

}

- setANNInactivityRange: (float) r andANNForecastAppAgentActDailyProb: (float) p; 
- setRuleMaster: r;
- setForecastingAgent: f;
- setMyUniformDblRand: u; // an ad hoc distribution, see comment in 
                          // modelSwarm.h and .m

- act0; // acting - placing buy or sell orders - before opening
- act1;  // placing buy or sell orders

@end
