// BasicSumAgent.h 

// This is the root Agent in Sum; all operating agents inherit from it,
// but ForecastingAgent; also CTAgent must inherit from it, to have
// accounting capality

#import <objectbase/SwarmObject.h>
#import <random.h>
#import <math.h> // to use fabs etc. 
#import "Book.h"
#import <simtoolsgui/GUISwarm.h> // to use CREATE_ARCHIVED_PROBE_DISPLAY
#import <simtoolsgui.h>          // ""
#import "Matrix2.h"

@interface BasicSumAgent: SwarmObject
{

  int number, maxOrderQuantity, iMax, executedPriceCount,
  printing, actingBeforeOpening;

  float price, 
        asymmetricBuySellProb, buySellSwitch,
        shareQuantity, shareValueAtMeanDailyPrice, 
        liquidityQuantity, agentWealthAtMeanDailyPrice,
        meanOperatingPrice;
  Matrix2 * executedPrices;
  Book * theBook;

}

- createEnd;

- setNumber: (int) n;

- setAsymmetricBuySellProb: (float) p;
- setMaxOrderQuantity: (int) m;

- setBook: b;
- setPrinting: (int) p;

- setConfirmationOfExecutedPrice: (float) p;

- act0; // defined for compatibilty reasons with currentAgent
- act1;  // "" ""
- act2; // accounting at the end of a day
- getProbe;
- (float) getWealthAtMeanDailyPrice;

@end


