// BasicSumAgent.m                                        

#import "BasicSumAgent.h"

@implementation BasicSumAgent

  // we set the agent number
- setNumber: (int) n
{
  number = n;
  return self;
}

- setAsymmetricBuySellProb: (float) p
{
  asymmetricBuySellProb=p;
  return self;
}

  // the address of the book of the market
- setBook: b
{
  theBook=b;
  return self;
}

  // how many orders are we placing at each time?
- setMaxOrderQuantity: (int) m
{
  maxOrderQuantity=m;
  return self;
}

  // this is a toggle: print / don't print
- setPrinting: (int) p
{
  printing=p;
  return self;
}

- createEnd
{
   [super createEnd];

   // initialize
   executedPriceCount=0;

   // keeping data for accounting reasons
   executedPrices=[Matrix2 createBegin: [self getZone]];
   [executedPrices setDimensionRows: maxOrderQuantity Cols: 1
                                                      Code: 1000+number];
   executedPrices=[executedPrices createEnd];

   shareQuantity=0;
   shareValueAtMeanDailyPrice=0;
   liquidityQuantity=0;
   agentWealthAtMeanDailyPrice=0;
   return self;
}

- act0  // defined for compatibility reasons with current agent
{
  return self;
}

- act1  // defined for compatibility reasons with current agent
{
  return self;
}


- setConfirmationOfExecutedPrice: (float) p
{
  [executedPrices R: executedPriceCount C: 0 setFrom: p];
  if(p!=0)++executedPriceCount;
  return self;
}

  // accounting
- act2
{
  float mP, q;
  int i;

  // accounting operation and display of
  // a message about the operation eventually done: if price is not zero
  // we have been buyer (executedPrice>0) or seller (executedPrice<0)
   if(printing==4)
   for(i=0;i<executedPriceCount;i++)
   printf("I'm agent #%3d and the book told me: %7.4f\n",
                                   number,[executedPrices R:i C:0]);
   

   mP=[theBook getMeanPrice];

   // quantity of shares
   q=0;
   for (i=0;i<executedPriceCount;i++)
   {
   if([executedPrices R:i C:0]>0)q++;
   if([executedPrices R:i C:0]<0)q--;
   }

   shareQuantity += q;

   shareValueAtMeanDailyPrice=shareQuantity*mP; 
                                        // meanPrice at the end of each "day"

   meanOperatingPrice=0; // used in CT
   for (i=0;i<executedPriceCount;i++)
     {
       liquidityQuantity  -= [executedPrices R:i C:0];
       meanOperatingPrice += fabs([executedPrices R:i C:0]);
     }

   if(executedPriceCount != 0) meanOperatingPrice/=executedPriceCount;
   else meanOperatingPrice=mP;

   if(printing==4)
   printf("I'm agent #%3d and the meanOperatingPrice is: %7.4f\n\n",
                                   number,meanOperatingPrice);
 

   agentWealthAtMeanDailyPrice=shareValueAtMeanDailyPrice+liquidityQuantity;

   return self;
}

- getProbe
{
  CREATE_ARCHIVED_PROBE_DISPLAY (self);
  return self;
}

- (float) getWealthAtMeanDailyPrice
{
  return agentWealthAtMeanDailyPrice;
}

@end











