// Book.h 

#import <objectbase/SwarmObject.h>
#import <collections.h>
#import "Matrix2.h"



@interface Book: SwarmObject
{

  id <Index> agentArrayIndex;
  Matrix2 * sellOrderStorehouse, * buyOrderStorehouse, * meanPriceHistory,
          * localHistory;
  int sellOrderNumber, buyOrderNumber, 
	  buyOrderNumberBeforeOpening, sellOrderNumberBeforeOpening, 
	  maxOrderQuantity, agentNumber, printing, meanPriceHistoryLength, localHistoryLength,
      nAheadForecasting;
  float price, executedPrice, meanPrice, currentMeanPrice, probMarketOrder,
        previousClosingPrice;
  int count;

}

- createEnd;
                              
- setAgentArrayIndex: i;
- setAgentNumber: (int) n;
- setMaxOrderQuantity: (int) m;
- setMeanPriceHistoryLength: (int) l;
- setLocalHistoryLength: (int) l;
- setPrinting: (int) p;
- setMeanPrice;

- setProbMarketOrder: (float) mo;
- setClean;
- setOrderBeforeOpeningFromAgent: (int) n atPrice: (float) p;
- setOrderFromAgent: (int) n atPrice: (float) p;
- setNAheadForecasting: (int) na;

- (float) getPrice;
- (float) getSpread;

- (float) getBuySellQuantitySpread; 
- (float) getBuyFirstLastSpread;
- (float) getSellFirstLastSpread;

- (float) getPreviousClosingPrice;
- (float) getMeanPrice;
- (float) getLaggedMeanPrice: (int) lag; // the methods
                                         // 'getLaggedMeanPrice: 1' and
                                         // 'getMeanPrice give the same
                                         // result
- (float) getMeanPriceIndex;
- (int) getLocalHistory; // the method returns
                         //                     a positive int if locally
                         // see localHistoryLength) the # of buying decisions
                         // is greater than the # of selling decisions
                         //                     a negative int in the
                         // opposite case
- (float) getSellOrderNumber;
- (float) getBuyOrderNumber;

- (float) getSellOrderNumberBeforeOpening;
- (float) getBuyOrderNumberBeforeOpening;

@end
